// {$R Kruskal.JFM}

import java.awt.*;
import java.util.*;
import java.applet.Applet;

class Arista{
    public String i;//pred
    public String j;//suc
    public float w;//peso
}

// Class Kruskal
public class Kruskal extends Applet
{
    final int MenuBarHeight = 0;

    Vector v = new Vector((int)20,(int)3);//vector de aristas
    Vector apm = new Vector((int)20,(int)3);//vector del arbol de peso mnimo
    Arista a=new Arista();

    // Component Declaration
    public TextField pred;
    public TextField suc;
    public TextField peso;
    public Label Label1;
    public Label Label2;
    public Label Label3;
    public Button addarista;
    public Button kbutton;
    public Button vadenuez;
    public TextArea output;
    // End of Component Declaration

    // init()
    public void init()
    {
        // Frame Initialization
        setForeground(Color.black);
        setBackground(Color.lightGray);
        setFont(new Font("Dialog",Font.BOLD,12));
        setLayout(null);
        // End of Frame Initialization

        // Component Initialization
        pred = new TextField("1");
        pred.setForeground(Color.black);
        pred.setBackground(Color.white);
        pred.setFont(new Font("Dialog",Font.BOLD,12));
        suc = new TextField("2");
        suc.setForeground(Color.black);
        suc.setBackground(Color.white);
        suc.setFont(new Font("Dialog",Font.BOLD,12));
        peso = new TextField("1.0");
        peso.setForeground(Color.black);
        peso.setBackground(Color.white);
        peso.setFont(new Font("Dialog",Font.BOLD,12));
        Label1 = new Label("Predecesor",Label.LEFT);
        Label1.setFont(new Font("Dialog",Font.BOLD,12));
        Label2 = new Label("Sucesor",Label.LEFT);
        Label2.setFont(new Font("Dialog",Font.BOLD,12));
        Label3 = new Label("Peso",Label.LEFT);
        Label3.setFont(new Font("Dialog",Font.BOLD,12));
        addarista = new Button("Agrega Arista");
        addarista.setFont(new Font("Dialog",Font.PLAIN,12));
        kbutton = new Button("Kruskal!");
        kbutton.setFont(new Font("Helvetica",Font.BOLD,40));
        vadenuez = new Button("Reset");
        vadenuez.setFont(new Font("Dialog",Font.PLAIN,12));
        output = new TextArea("Bienvenido al Super Kruskal mgico y mstico del to Escorbuto...\n");
        output.setForeground(Color.black);
        output.setBackground(Color.white);
        // output.setFont(new Font("Dialog",Font.BOLD,12));
        // End of Component Initialization

        // Add()s
        add(output);
        add(vadenuez);
        add(kbutton);
        add(addarista);
        add(Label3);
        add(Label2);
        add(Label1);
        add(peso);
        add(suc);
        add(pred);
        // End of Add()s

        InitialPositionSet();
    } // End of init()

    void sort(){
        int i,j,men;
        Arista a1= new Arista(),a2=new Arista();
        for(j=0;(j<v.size());j++){
            men=j;
            for(i=j;(i<v.size());i++){
                a1=(Arista)v.elementAt(men);
                a2=(Arista)v.elementAt(i);
                if (a1.w>a2.w)
                    men=i;
            }
            a=(Arista)v.elementAt(j);
            v.setElementAt(v.elementAt(men),j);
            v.setElementAt(a,men);
        }
    }
    
    void show(Vector vec, String msg){
        int i;
        Arista ar=new Arista();
        output.appendText(msg+"\n");
        for(i=0;i<vec.size();i++){
            ar= (Arista)vec.elementAt(i);
            output.appendText("    ("+ar.i+" , "+ar.j+") = "+String.valueOf(ar.w)+"\n");
        }
    }
    
    void krusk(){
        Vector ya= new Vector((int)20,(int)3);
        int i,j;
        for(i=0;i<v.size();i++){
            a= (Arista) v.elementAt(i);
            apm.addElement(a);
            if (!ya.contains(a.i)) ya.addElement(a.i);
            if (!ya.contains(a.j)) ya.addElement(a.j);
            if (apm.size()>=ya.size()){//ciclo
                apm.removeElement(a);
            }
        }
    
    }

    public boolean action(Event event, Object what) {
        boolean ok=true;
        if (event.target instanceof Button) {
            Button b = (Button) event.target;
            if (b.getLabel() == "Agrega Arista"){
                a= new Arista();
                try{
                    a.w=Float.valueOf(peso.getText()).floatValue();
                }
                catch(NumberFormatException e){
                  output.appendText("Fijate!\n");
                  ok=false;
                }
                if (ok){
                    a.i=pred.getText();
                    a.j=suc.getText();
                    v.addElement(a);
                    output.appendText("Arista agregada: ("+a.i+" , "+a.j+") = "+String.valueOf(a.w)+"\n");
                }
                  
            }
            else  if (b.getLabel() == "Reset") {
                v.removeAllElements();
                apm.removeAllElements();
                output.appendText("Va de nuez...\n");
            }
            else  if (b.getLabel() == "Kruskal!") {
                show(v, "Aristas...");
                sort();
                show(v, "Ordenadas...");
                krusk();
                show(apm,"rbol de peso mnimo:");
                apm.removeAllElements();
            }
        }
        return true;
    }



    // start()
    public void start()
    {
    } // End of start()

    // stop()
    public void stop()
    {
    } // End of stop()

    // destroy()
    public void destroy()
    {
    } // End of destroy()

    public void paint(Graphics g)
    {
        // paint()
        // End of paint()
    }

    public void InitialPositionSet()
    {
        // InitialPositionSet()
        resize(492,314);
        pred.reshape(120,17+MenuBarHeight,121,27);
        suc.reshape(120,48+MenuBarHeight,121,27);
        peso.reshape(120,80+MenuBarHeight,121,27);
        Label1.reshape(16,23+MenuBarHeight,95,19);
        Label2.reshape(38,53+MenuBarHeight,83,19);
        Label3.reshape(61,83+MenuBarHeight,51,19);
        addarista.reshape(120,114+MenuBarHeight,118,25);
        kbutton.reshape(248,15+MenuBarHeight,225,126);
        vadenuez.reshape(30,114+MenuBarHeight,80,25);
        output.reshape(14,153+MenuBarHeight,460,142);
        // End of InitialPositionSet()
    }

    public boolean handleEvent(Event evt)
    {
        // handleEvent()
        if (evt.id == Event.WINDOW_DESTROY && evt.target == this) noname01_WindowDestroy(evt.target);
        // End of handleEvent()

        return super.handleEvent(evt);
    }

    // Event Handling Routines
    public void noname01_WindowDestroy(Object target)
    {
        System.exit(0);
    }

    // End of Event Handling Routines

} // End of Class Kruskal

